@DATABASE "dopus/diskio.h"
@MASTER   "opussdk:include/dopus/diskio.h"
@REMARK   (c) Dr Greg Perry and Jonathan Potter, GPSoftware 1996
@REMARK   This file was initially created by ADtoHT 2.1 on 07-Sep-96 18:20:14
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "dopus/diskio.h"
@TOC "DopusSDK/MAIN"

@{"dopus/diskio.h" LINK File}


@{b}Typedefs@{ub}

@{"DiskHandle" LINK "dopus/diskio.h/File" 10}


@{b}#defines@{ub}

@{"ID_AFS_MULTI" LINK "dopus/diskio.h/File" 28}  @{"ID_AFS_PRO" LINK "dopus/diskio.h/File" 26}  @{"ID_AFS_USER" LINK "dopus/diskio.h/File" 27}  @{"ID_PFS_FLOPPY" LINK "dopus/diskio.h/File" 29}
@{"ID_PFS_HARD" LINK "dopus/diskio.h/File" 30}   

@ENDNODE
@NODE File "dopus/diskio.h"
#ifndef _DOPUS_DISKIO
#define _DOPUS_DISKIO

/*****************************************************************************

 Disk I/O

 *****************************************************************************/

typedef struct
        struct MsgPort                  *dh_Port;       // Message port
        struct IOExtTD                  *dh_IO;         // IO request
        struct FileSysStartupMsg        *dh_Startup;    // Startup message
        struct DosEnvec                 *dh_Geo;        // Disk geometry
        char                            dh_Name[32];    // Disk name
        char                            dh_Device[32];  // Device name
        struct InfoData                 dh_Info;        // Disk information
        unsigned long                   dh_Result;      // dh_Info is valid
        unsigned long                   dh_Root;        // Root block
        unsigned long                   dh_BlockSize;   // Block size
        struct DateStamp                dh_Stamp;       // not used
} DiskHandle;

// Some third-party DOS types
#define ID_AFS_PRO              0x41465301
#define ID_AFS_USER             0x41465302
#define ID_AFS_MULTI            0x6D754146
#define ID_PFS_FLOPPY           0x50465300
#define ID_PFS_HARD             0x50465301

@{"DiskHandle" LINK File 10} *OpenDisk(char *,struct MsgPort *);
void CloseDisk(@{"DiskHandle" LINK File 10} *);

#endif
@ENDNODE
