@DATABASE "dopus/drag.h"
@MASTER   "opussdk:include/dopus/drag.h"
@REMARK   (c) Dr Greg Perry and Jonathan Potter, GPSoftware 1996
@REMARK   This file was initially created by ADtoHT 2.1 on 07-Sep-96 18:20:14
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "dopus/drag.h"
@TOC "DopusSDK/MAIN"

@{"dopus/drag.h" LINK File}


@{b}Structures@{ub}

@{"_DragInfo" LINK "dopus/drag.h/File" 14}


@{b}Typedefs@{ub}

@{"DragInfo" LINK "dopus/drag.h/File" 14}  @{"DragInfoExtra" LINK "dopus/drag.h/File" 33}


@{b}#defines@{ub}

@{"DRAGF_DONE_GELS" LINK "dopus/drag.h/File" 42}    @{"DRAGF_NO_LOCK" LINK "dopus/drag.h/File" 43}  @{"DRAGF_OPAQUE" LINK "dopus/drag.h/File" 41}
@{"DRAGF_TRANSPARENT" LINK "dopus/drag.h/File" 44}  @{"DRAGF_VALID" LINK "dopus/drag.h/File" 40}    

@ENDNODE
@NODE File "dopus/drag.h"
#ifndef _DOPUS_DRAG
#define _DOPUS_DRAG

/*****************************************************************************

 Drag routines

 *****************************************************************************/

#ifndef GRAPHICS_GELS_H
#include <graphics/gels.h>
#endif

typedef struct _DragInfo
{
        struct RastPort *rastport;      // Stores RastPort this bob belongs to
        struct ViewPort *viewport;      // Stores ViewPort

        WORD            width;          // Bob width
        WORD            height;         // Bob height

        struct VSprite  sprite;         // VSprite structure
        struct Bob      bob;            // BOB structure

        unsigned long   flags;          // Flags

        struct RastPort drag_rp;        // RastPort we can draw into
        struct BitMap   drag_bm;        // BitMap we can draw into

        struct Window   *window;        // Window pointer
} DragInfo;

typedef struct
        struct VSprite  head;           // GEL list head sprite
        struct VSprite  tail;           // GEL list tail sprite
        struct GelsInfo info;           // GEL info
} DragInfoExtra;

#define DRAGF_VALID             (1<<0)  // Bob is valid
#define DRAGF_OPAQUE            (1<<1)  // Bob should be opaque
#define DRAGF_DONE_GELS         (1<<2)  // Installed GelsInfo
#define DRAGF_NO_LOCK           (1<<3)  // Don't lock layers
#define DRAGF_TRANSPARENT       (1<<4)  // Bob should be transparent (use with opaque)

void FreeDragInfo(@{"DragInfo" LINK File 14} *);
void GetDragImage(@{"DragInfo" LINK File 14} *,long,long);
@{"DragInfo" LINK File 14} *GetDragInfo(struct Window *,struct RastPort *,long,long,long);
void GetDragMask(@{"DragInfo" LINK File 14} *);
void HideDragImage(@{"DragInfo" LINK File 14} *);
void ShowDragImage(@{"DragInfo" LINK File 14} *,long,long);
void StampDragImage(@{"DragInfo" LINK File 14} *,long,long);


#endif
@ENDNODE
