@DATABASE "dopus/modules.h"
@MASTER   "opussdk:include/dopus/modules.h"
@REMARK   (c) Dr Greg Perry and Jonathan Potter, GPSoftware 1996
@REMARK   This file was initially created by ADtoHT 2.1 on 07-Sep-96 18:20:14
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "dopus/modules.h"
@TOC "DopusSDK/MAIN"

@{"dopus/modules.h" LINK File}


@{b}Structures@{ub}

@{"addfile_packet" LINK "dopus/modules.h/File" 127}   @{"command_packet" LINK "dopus/modules.h/File" 185}   @{"delfile_packet" LINK "dopus/modules.h/File" 135}
@{"DOpusScreenData" LINK "dopus/modules.h/File" 173}  @{"endentry_packet" LINK "dopus/modules.h/File" 120}  @{"function_entry" LINK "dopus/modules.h/File" 94}
@{"loadfile_packet" LINK "dopus/modules.h/File" 143}  @{"path_node" LINK "dopus/modules.h/File" 103}        @{"replacereq_packet" LINK "dopus/modules.h/File" 155}


@{b}Typedefs@{ub}

@{"ModuleFunction" LINK "dopus/modules.h/File" 16}  @{"ModuleInfo" LINK "dopus/modules.h/File" 41}


@{b}#defines@{ub}

@{"COMMANDF_RESULT" LINK "dopus/modules.h/File" 193}         @{"EXT_FUNC()" LINK "dopus/modules.h/File" 202}
@{"EXTCMD_ADD_FILE" LINK "dopus/modules.h/File" 79}         @{"EXTCMD_CHECK_ABORT" LINK "dopus/modules.h/File" 73}
@{"EXTCMD_DEL_FILE" LINK "dopus/modules.h/File" 88}         @{"EXTCMD_DO_CHANGES" LINK "dopus/modules.h/File" 89}
@{"EXTCMD_END_DEST" LINK "dopus/modules.h/File" 78}         @{"EXTCMD_END_ENTRY" LINK "dopus/modules.h/File" 71}
@{"EXTCMD_END_SOURCE" LINK "dopus/modules.h/File" 77}       @{"EXTCMD_ENTRY_COUNT" LINK "dopus/modules.h/File" 74}
@{"EXTCMD_FREE_SCREENDATA" LINK "dopus/modules.h/File" 86}  @{"EXTCMD_GET_DEST" LINK "dopus/modules.h/File" 76}
@{"EXTCMD_GET_ENTRY" LINK "dopus/modules.h/File" 70}        @{"EXTCMD_GET_HELP" LINK "dopus/modules.h/File" 80}
@{"EXTCMD_GET_PORT" LINK "dopus/modules.h/File" 81}         @{"EXTCMD_GET_SCREEN" LINK "dopus/modules.h/File" 82}
@{"EXTCMD_GET_SCREENDATA" LINK "dopus/modules.h/File" 85}   @{"EXTCMD_GET_SOURCE" LINK "dopus/modules.h/File" 67}
@{"EXTCMD_GET_WINDOW" LINK "dopus/modules.h/File" 75}       @{"EXTCMD_LOAD_FILE" LINK "dopus/modules.h/File" 90}
@{"EXTCMD_NEXT_SOURCE" LINK "dopus/modules.h/File" 68}      @{"EXTCMD_RELOAD_ENTRY" LINK "dopus/modules.h/File" 72}
@{"EXTCMD_REMOVE_ENTRY" LINK "dopus/modules.h/File" 84}     @{"EXTCMD_REPLACE_REQ" LINK "dopus/modules.h/File" 83}
@{"EXTCMD_SEND_COMMAND" LINK "dopus/modules.h/File" 87}     @{"EXTCMD_UNLOCK_SOURCE" LINK "dopus/modules.h/File" 69}
@{"FUNCF_CAN_DO_ICONS" LINK "dopus/modules.h/File" 31}      @{"FUNCF_NEED_DEST" LINK "dopus/modules.h/File" 27}
@{"FUNCF_NEED_DIRS" LINK "dopus/modules.h/File" 29}         @{"FUNCF_NEED_ENTRIES" LINK "dopus/modules.h/File" 30}
@{"FUNCF_NEED_FILES" LINK "dopus/modules.h/File" 28}        @{"FUNCF_NEED_SOURCE" LINK "dopus/modules.h/File" 26}
@{"FUNCF_PRIVATE" LINK "dopus/modules.h/File" 37}           @{"FUNCF_SINGLE_DEST" LINK "dopus/modules.h/File" 33}
@{"FUNCF_SINGLE_SOURCE" LINK "dopus/modules.h/File" 32}     @{"FUNCF_WANT_DEST" LINK "dopus/modules.h/File" 34}
@{"FUNCF_WANT_ENTRIES" LINK "dopus/modules.h/File" 36}      @{"FUNCF_WANT_SOURCE" LINK "dopus/modules.h/File" 35}
@{"FUNCID_STARTUP" LINK "dopus/modules.h/File" 64}          @{"IDCMP_FUNC()" LINK "dopus/modules.h/File" 205}
@{"LFF_ICON" LINK "dopus/modules.h/File" 151}                @{"MODULEF_CALL_STARTUP" LINK "dopus/modules.h/File" 60}
@{"MODULEF_STARTUP_SYNC" LINK "dopus/modules.h/File" 61}    @{"REPLACE_ABORT" LINK "dopus/modules.h/File" 166}
@{"REPLACE_LEAVE" LINK "dopus/modules.h/File" 167}           @{"REPLACE_REPLACE" LINK "dopus/modules.h/File" 168}
@{"REPLACEF_ALL" LINK "dopus/modules.h/File" 169}            @{"TYPE_EXT()" LINK "dopus/modules.h/File" 203}

@ENDNODE
@NODE File "dopus/modules.h"
#ifndef _DOPUS_MODULES
#define _DOPUS_MODULES

/****************************************************************************

 Support file for DOpus modules

 ****************************************************************************/

#ifndef _DOPUSBASE
#include <@{"dopus/dopusbase.h" LINK "dopus/dopusbase.h/File"}>
#endif


// Defines a function in a module
typedef struct
        ULONG   id;             // Function ID code
        char    *name;          // Function name
        ULONG   desc;           // Locale string ID for function description
        ULONG   flags;          // Function flags
        char    *template;      // Command template
} ModuleFunction;

// Function flags
#define FUNCF_NEED_SOURCE               (1<<0)  // Needs a source directory
#define FUNCF_NEED_DEST                 (1<<1)  // Needs a destination directory
#define FUNCF_NEED_FILES                (1<<2)  // Needs some files to work with
#define FUNCF_NEED_DIRS                 (1<<3)  // Needs some files to work with
#define FUNCF_NEED_ENTRIES      (@{"FUNCF_NEED_FILES" LINK File 28}|@{"FUNCF_NEED_DIRS" LINK File 29})
#define FUNCF_CAN_DO_ICONS              (1<<6)  // Function can do icons
#define FUNCF_SINGLE_SOURCE             (1<<8)  // Only a single source needed
#define FUNCF_SINGLE_DEST               (1<<9)  // Only a single destination needed
#define FUNCF_WANT_DEST                 (1<<11) // Want destinations, don't need them
#define FUNCF_WANT_SOURCE               (1<<12) // Want source, don't need it
#define FUNCF_WANT_ENTRIES              (1<<19) // Want entries
#define FUNCF_PRIVATE                   (1<<26) // Function is private


// Defines all the functions in a module
typedef struct
        ULONG           ver;            // Module version
        char            *name;          // Module name
        char            *locale_name;   // Catalog name
        ULONG           flags;          // Module flags
        ULONG           function_count; // Number of functions in module
        @{"ModuleFunction" LINK File 16}  function[1];    // Definition of first function
} ModuleInfo;


/*** If the module has more than one function, the additional @{"ModuleFunction" LINK File 16}
     structures MUST follow the @{"ModuleInfo" LINK File 41} structure in memory. Eg,

     @{"ModuleInfo" LINK File 41} module_info={....};
     @{"ModuleFunction" LINK File 16} more_funcs[2]={{...},{...}};                           ***/


// Flags for @{"ModuleInfo" LINK File 41}
#define MODULEF_CALL_STARTUP            (1<<0)  // Call ModuleEntry() on startup
#define MODULEF_STARTUP_SYNC            (1<<1)  // Run Synchronously on startup

// ID passed to Module_Entry() if module is run on startup
#define FUNCID_STARTUP                  0xffffffff

// Callback commands
#define EXTCMD_GET_SOURCE       0       // Get current source path
#define EXTCMD_NEXT_SOURCE      1       // Get next source path
#define EXTCMD_UNLOCK_SOURCE    2       // Unlock source paths
#define EXTCMD_GET_ENTRY        3       // Get entry
#define EXTCMD_END_ENTRY        4       // End entry
#define EXTCMD_RELOAD_ENTRY     5       // Reload entry
#define EXTCMD_CHECK_ABORT      9       // Check abort status
#define EXTCMD_ENTRY_COUNT      10      // Get entry count
#define EXTCMD_GET_WINDOW       11      // Get window handle
#define EXTCMD_GET_DEST         12      // Get next destination
#define EXTCMD_END_SOURCE       13      // Cleanup current source path
#define EXTCMD_END_DEST         14      // Cleanup current destination path
#define EXTCMD_ADD_FILE         16      // Add a file to a lister
#define EXTCMD_GET_HELP         17      // Get help on a topic
#define EXTCMD_GET_PORT         18      // Get ARexx port name
#define EXTCMD_GET_SCREEN       19      // Get public screen name
#define EXTCMD_REPLACE_REQ      20      // Show exists/replace? requester
#define EXTCMD_REMOVE_ENTRY     21      // Mark an entry for removal
#define EXTCMD_GET_SCREENDATA   22      // Get DOpus screen data
#define EXTCMD_FREE_SCREENDATA  23      // Free screen data
#define EXTCMD_SEND_COMMAND     30      // Send a command to DOpus
#define EXTCMD_DEL_FILE         31      // Delete a file from a lister
#define EXTCMD_DO_CHANGES       32      // Perform changes
#define EXTCMD_LOAD_FILE        33      // Load files to listers


// Structures used with callback commands
struct function_entry
{
        ULONG                   pad[2];
        char                    *name;  // File name
        APTR                    entry;  // Entry pointer (don't touch!)
        short                   type;   // Type of file
        short                   flags;  // File flags
};

struct path_node
{
        ULONG                   pad[2];
        char                    buffer[512];    // Contains path string
        char                    *path;          // Points to path string
        APTR                    lister;         // Lister pointer
        ULONG                   flags;          // Flags
};


/****************************************************************************

 Packets used to send commands

 ****************************************************************************/

// @{"EXTCMD_END_ENTRY" LINK File 71}
struct endentry_packet
{
        @{"struct function_entry" LINK File 94}   *entry;         // Entry pointer
        BOOL                    deselect;       // TRUE to deselect entry
};

// @{"EXTCMD_ADD_FILE" LINK File 79}
struct addfile_packet
{
        char                    *path;          // Path to add file to
        struct FileInfoBlock    *fib;           // FileInfoBlock to add
        struct ListerWindow     *lister;        // Lister pointer
};

// @{"EXTCMD_DEL_FILE" LINK File 88}
struct delfile_packet
{
        char                    *path;          // Path to delete file from
        char                    *name;          // Name of file to delete
        struct ListerWindow     *lister;        // Lister pointer
};

// @{"EXTCMD_LOAD_FILE" LINK File 90}
struct loadfile_packet
{
        char                    *path;          // Path of file
        char                    *name;          // File name
        short                   flags;          // Flags field
        short                   reload;         // TRUE to reload existing file
};

#define LFF_ICON                (1<<0)


// @{"EXTCMD_REPLACE_REQ" LINK File 83}
struct replacereq_packet
{
        struct Window           *window;        // Window to open over
        struct Screen           *screen;        // Screen to open on
        @{"IPCData" LINK "dopus/ipc.h/File" 24}                 *ipc;           // Your process IPC pointer
        struct FileInfoBlock    *file1;         // First file
        struct FileInfoBlock    *file2;         // Second file
        short                   flags;          // Flags
};

// Result code from @{"EXTCMD_REPLACE_REQ" LINK File 83}
#define REPLACE_ABORT           -1
#define REPLACE_LEAVE           0
#define REPLACE_REPLACE         1
#define REPLACEF_ALL            (1<<1)


// @{"EXTCMD_GET_SCREENDATA" LINK File 85}
struct DOpusScreenData
{
        struct Screen           *screen;        // Screen pointer
        struct DrawInfo         *draw_info;     // DrawInfo pointer
        unsigned short          depth;          // Screen depth
        unsigned short          pen_alloc;      // Mask of allocated pens
        unsigned short          pen_array[16];  // Pen array
        short                   pen_count;      // Number of pens
};


// @{"EXTCMD_SEND_COMMAND" LINK File 87}
struct command_packet
{
        char                    *command;       // Command to send
        ULONG                   flags;          // Command flags
        char                    *result;        // Will point to result string
        ULONG                   rc;             // Return code
};

#define COMMANDF_RESULT         (1<<0)


// Prototype for the callback hook
ULONG __asm __saveds function_external_hook(
        register __d0 ULONG command,
        register __a0 APTR handle,
        register __a1 APTR packet);

#define EXT_FUNC(name)  unsigned long __asm (*name)(register __d0 ULONG,register __a0 APTR,register __a1 APTR)
#define TYPE_EXT(var)   (unsigned long (*)())var

#define IDCMP_FUNC(name)        unsigned long __asm (*name)(register __d0 ULONG,register __a0 struct IntuiMessage *)



/**** Define this if you are using the standard modinit.o code ****/
#ifdef _DOPUS_MODULE_DEF

// These library bases are defined and made available automatically
extern struct Library *DOSBase;
extern struct Library *DOpusBase;
extern struct Library *IntuitionBase;
extern struct Library *GfxBase;
extern struct Library *IconBase;
extern struct Library *UtilityBase;
extern struct Library *LayersBase;
extern struct Library *GadToolsBase;
extern struct Library *AslBase;
extern struct Library *DiskfontBase;
extern struct Library *RexxSysBase;
extern struct Library *TimerBase;
extern struct Library *LocaleBase;
extern struct Library *WorkbenchBase;

// Global pointer to a module's locale information
extern @{"struct DOpusLocale" LINK "dopus/locale.h/File" 11} *locale;
void init_locale_data(@{"struct DOpusLocale" LINK "dopus/locale.h/File" 11} *);

// You MUST define the @{"ModuleInfo" LINK File 41} structure yourself
extern @{"ModuleInfo" LINK File 41} module_info;

#endif

#endif
@ENDNODE
