@DATABASE "dopus/notify.h"
@MASTER   "opussdk:include/dopus/notify.h"
@REMARK   (c) Dr Greg Perry and Jonathan Potter, GPSoftware 1996
@REMARK   This file was initially created by ADtoHT 2.1 on 07-Sep-96 18:20:14
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "dopus/notify.h"
@TOC "DopusSDK/MAIN"

@{"dopus/notify.h" LINK File}


@{b}Typedefs@{ub}

@{"DOpusNotify" LINK "dopus/notify.h/File" 11}


@{b}#defines@{ub}

@{"DN_APP_ICON_LIST" LINK "dopus/notify.h/File" 27}     @{"DN_APP_MENU_LIST" LINK "dopus/notify.h/File" 28}
@{"DN_CLOSE_WORKBENCH" LINK "dopus/notify.h/File" 29}   @{"DN_DISKCHANGE" LINK "dopus/notify.h/File" 32}
@{"DN_DOS_ACTION" LINK "dopus/notify.h/File" 37}        @{"DN_OPEN_WORKBENCH" LINK "dopus/notify.h/File" 30}
@{"DN_OPUS_HIDE" LINK "dopus/notify.h/File" 34}         @{"DN_OPUS_QUIT" LINK "dopus/notify.h/File" 33}
@{"DN_OPUS_SHOW" LINK "dopus/notify.h/File" 35}         @{"DN_OPUS_START" LINK "dopus/notify.h/File" 36}
@{"DN_RESET_WORKBENCH" LINK "dopus/notify.h/File" 31}   @{"DN_REXX_UP" LINK "dopus/notify.h/File" 38}
@{"DN_WRITE_ICON" LINK "dopus/notify.h/File" 26}        @{"DNF_DOS_CLOSE" LINK "dopus/notify.h/File" 52}
@{"DNF_DOS_CREATE" LINK "dopus/notify.h/File" 51}       @{"DNF_DOS_CREATEDIR" LINK "dopus/notify.h/File" 45}
@{"DNF_DOS_DELETEFILE" LINK "dopus/notify.h/File" 46}   @{"DNF_DOS_RELABEL" LINK "dopus/notify.h/File" 53}
@{"DNF_DOS_RENAME" LINK "dopus/notify.h/File" 50}       @{"DNF_DOS_SETCOMMENT" LINK "dopus/notify.h/File" 48}
@{"DNF_DOS_SETFILEDATE" LINK "dopus/notify.h/File" 47}  @{"DNF_DOS_SETPROTECTION" LINK "dopus/notify.h/File" 49}
@{"DNF_ICON_CHANGED" LINK "dopus/notify.h/File" 42}     @{"DNF_ICON_REMOVED" LINK "dopus/notify.h/File" 41}
@{"NT_DOPUS_NOTIFY" LINK "dopus/notify.h/File" 23}      

@ENDNODE
@NODE File "dopus/notify.h"
#ifndef _DOPUS_NOTIFY
#define _DOPUS_NOTIFY

/*****************************************************************************

 Notification

 *****************************************************************************/

// Notification message
typedef struct
        struct Message          dn_Msg;         // Message header
        ULONG                   dn_Type;        // Type of message
        ULONG                   dn_UserData;    // User-supplied data
        ULONG                   dn_Data;        // Message-specific data
        ULONG                   dn_Flags;       // Flags
        struct FileInfoBlock    *dn_Fib;        // FIB for some messages
        char                    dn_Name[1];     // Name for some messages
} DOpusNotify;

// dn_Msg.mn_Node.ln_Type
#define NT_DOPUS_NOTIFY         199

// dn_Type
#define DN_WRITE_ICON           (1<<0)          // Icon written
#define DN_APP_ICON_LIST        (1<<1)          // AppIcon added/removed
#define DN_APP_MENU_LIST        (1<<2)          // AppMenu added/removed
#define DN_CLOSE_WORKBENCH      (1<<3)          // Workbench closed
#define DN_OPEN_WORKBENCH       (1<<4)          // Workbench opened
#define DN_RESET_WORKBENCH      (1<<5)          // Workbench reset
#define DN_DISKCHANGE           (1<<6)          // Disk inserted/removed
#define DN_OPUS_QUIT            (1<<7)          // Main program quit
#define DN_OPUS_HIDE            (1<<8)          // Main program hide
#define DN_OPUS_SHOW            (1<<9)          // Main program show
#define DN_OPUS_START           (1<<10)         // Main program start
#define DN_DOS_ACTION           (1<<11)         // DOS action
#define DN_REXX_UP              (1<<12)         // REXX started

// Flags with @{"DN_WRITE_ICON" LINK File 26}
#define DNF_ICON_REMOVED        (1<<0)          // Icon removed
#define DNF_ICON_CHANGED        (1<<1)          // Image changed

// Flags with @{"DN_DOS_ACTION" LINK File 37}
#define DNF_DOS_CREATEDIR       (1<<0)          // CreateDir
#define DNF_DOS_DELETEFILE      (1<<1)          // DeleteFile
#define DNF_DOS_SETFILEDATE     (1<<2)          // SetFileDate
#define DNF_DOS_SETCOMMENT      (1<<3)          // SetComment
#define DNF_DOS_SETPROTECTION   (1<<4)          // SetProtection
#define DNF_DOS_RENAME          (1<<5)          // Rename
#define DNF_DOS_CREATE          (1<<6)          // Open file (create)
#define DNF_DOS_CLOSE           (1<<7)          // Close file
#define DNF_DOS_RELABEL         (1<<8)          // Relabel disk

APTR AddNotifyRequest(ULONG,ULONG,struct MsgPort *);
void RemoveNotifyRequest(APTR);
void ReplyFreeMsg(struct Message *);
void SetNotifyRequest(APTR,ULONG,ULONG);


#endif
@ENDNODE
