@DATABASE "dopus/requesters.h"
@MASTER   "opussdk:include/dopus/requesters.h"
@REMARK   (c) Dr Greg Perry and Jonathan Potter, GPSoftware 1996
@REMARK   This file was initially created by ADtoHT 2.1 on 07-Sep-96 18:20:14
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "dopus/requesters.h"
@TOC "DopusSDK/MAIN"

@{"dopus/requesters.h" LINK File}


@{b}#defines@{ub}

@{"AR_Buffer" LINK "dopus/requesters.h/File" 26}        @{"AR_BufLen" LINK "dopus/requesters.h/File" 27}       @{"AR_Button" LINK "dopus/requesters.h/File" 23}      @{"AR_ButtonCode" LINK "dopus/requesters.h/File" 24}
@{"AR_CheckMark" LINK "dopus/requesters.h/File" 29}     @{"AR_CheckPtr" LINK "dopus/requesters.h/File" 30}     @{"AR_Flags" LINK "dopus/requesters.h/File" 31}       @{"AR_History" LINK "dopus/requesters.h/File" 28}
@{"AR_Message" LINK "dopus/requesters.h/File" 22}       @{"AR_Requester" LINK "dopus/requesters.h/File" 18}    @{"AR_Screen" LINK "dopus/requesters.h/File" 21}      @{"AR_Title" LINK "dopus/requesters.h/File" 25}
@{"AR_Window" LINK "dopus/requesters.h/File" 20}        @{"REF_CALLBACK()" LINK "dopus/requesters.h/File" 45}  @{"SLF_DIR_FIELD" LINK "dopus/requesters.h/File" 54}  @{"SRF_CENTJUST" LINK "dopus/requesters.h/File" 35}
@{"SRF_CHECKMARK" LINK "dopus/requesters.h/File" 39}    @{"SRF_HISTORY" LINK "dopus/requesters.h/File" 37}     @{"SRF_LONGINT" LINK "dopus/requesters.h/File" 34}    @{"SRF_MOUSE_POS" LINK "dopus/requesters.h/File" 41}
@{"SRF_PATH_FILTER" LINK "dopus/requesters.h/File" 38}  @{"SRF_RIGHTJUST" LINK "dopus/requesters.h/File" 36}   @{"SRF_SECURE" LINK "dopus/requesters.h/File" 40}     

@ENDNODE
@NODE File "dopus/requesters.h"
#ifndef _DOPUS_REQ
#define _DOPUS_REQ

/*****************************************************************************

 Requesters

 *****************************************************************************/


// Requesters available
enum
{
        REQTYPE_FILE,
        REQTYPE_SIMPLE,
};

#define AR_Requester    TAG_USER + 1            // Pointer to requester

#define AR_Window       TAG_USER + 2            // Window
#define AR_Screen       TAG_USER + 3            // Screen
#define AR_Message      TAG_USER + 4            // Text message
#define AR_Button       TAG_USER + 5            // Button label
#define AR_ButtonCode   TAG_USER + 6            // Code for this button
#define AR_Title        TAG_USER + 7            // Title string
#define AR_Buffer       TAG_USER + 8            // String buffer
#define AR_BufLen       TAG_USER + 9            // Buffer length
#define AR_History      TAG_USER + 10           // History list
#define AR_CheckMark    TAG_USER + 11           // Check mark text
#define AR_CheckPtr     TAG_USER + 12           // Check mark data storage
#define AR_Flags        TAG_USER + 13           // Flags

// Flags for REQTYPE_SIMPLE
#define SRF_LONGINT                     (1<<0)  // Integer gadget
#define SRF_CENTJUST                    (1<<1)  // Center justify
#define SRF_RIGHTJUST                   (1<<2)  // Right justify
#define SRF_HISTORY                     (1<<8)  // History supplied
#define SRF_PATH_FILTER                 (1<<9)  // Filter path characters
#define SRF_CHECKMARK                   (1<<11) // Checkmark supplied
#define SRF_SECURE                      (1<<12) // Secure field
#define SRF_MOUSE_POS                   (1<<13) // Position over mouse pointer

// Used to declare a callback for a requester
#ifndef REF_CALLBACK
#define @{"REF_CALLBACK" LINK "dopus/popup.h/File" 31}(name)      void __asm (*name)(register __d0 ULONG,register __a0 APTR,register __a1 APTR)
#endif

long AsyncRequest(@{"IPCData" LINK "dopus/ipc.h/File" 24} *,long,struct Window *,REF_CALLBACK(),APTR,struct TagItem *);
long __stdargs AsyncRequestTags(@{"IPCData" LINK "dopus/ipc.h/File" 24} *,long,struct Window *,REF_CALLBACK(),APTR,Tag,...);


// SelectionList

#define SLF_DIR_FIELD                   (1<<0)  // Directory field

short SelectionList(@{"Att_List" LINK "dopus/lists.h/File" 10} *,struct Window *,struct Screen *,char *,short,ULONG,char *,char *,char *);


// Status window
struct Window *OpenStatusWindow(char *,char *,struct Screen *,LONG,ULONG);
void SetStatusText(struct Window *,char *);

#endif
@ENDNODE
